export interface TextIterator extends Iterator<string>, Iterable<string> {
    next(skip?: number): this;
    value: string;
    done: boolean;
    lineBreak: boolean;
}
export declare abstract class Text implements Iterable<string> {
    abstract readonly length: number;
    abstract readonly lines: number;
    lineAt(pos: number): Line;
    line(n: number): Line;
    replace(from: number, to: number, text: Text): Text;
    append(other: Text): Text;
    slice(from: number, to?: number): Text;
    abstract sliceString(from: number, to?: number, lineSep?: string): string;
    eq(other: Text): boolean;
    iter(dir?: 1 | -1): TextIterator;
    iterRange(from: number, to?: number): TextIterator;
    iterLines(from?: number, to?: number): TextIterator;
    toJSON(): string[];
    abstract readonly children: readonly Text[] | null;
    [Symbol.iterator]: () => Iterator<string>;
    static of(text: readonly string[]): Text;
    static empty: Text;
}
export declare class Line {
    readonly from: number;
    readonly to: number;
    readonly number: number;
    readonly text: string;
    get length(): number;
}
